
#include "stdafx.h"
#include <windows.h> 
#include <winsock.h>
#include "TCPWIN.h"
#include "TCPWINDlg.h"


#define PORTNUM               5000    // Port number  
#define MAX_PENDING_CONNECTS  4       // Maximum length of the queue 
                                      // of pending connections



UINT	CTCPWINDlg::ThreadServer(LPVOID Par)
{
CTCPWINDlg* m_Dlg = (CTCPWINDlg*)Par;


SOCKET WinSocket = INVALID_SOCKET,  // Window socket
         ClientSock = INVALID_SOCKET; // Socket for communicating 
                                      // between the server and client
SOCKADDR_IN local_sin,              // Local socket address
              accept_sin;             // Receives the address of the 
                                      // connecting entity
int accept_sin_len;                 // Length of accept_sin
TCHAR szError[100];                 // Error message string
PHOSTENT phostent = NULL;

char image[198304];                // ASCII string 
char *pimage;
  


// Create a TCP/IP socket, WinSocket.
if ((WinSocket = socket (AF_INET, SOCK_STREAM, 0)) == INVALID_SOCKET)  {
    wsprintf (szError, TEXT("Allocating socket failed. Error: %d"), 
              WSAGetLastError ());
    m_Dlg->MessageBox (szError, TEXT("Error"), MB_OK);
    return FALSE;
}

// Fill out the local socket's address information.
local_sin.sin_family = AF_INET;
local_sin.sin_port = htons (3000);  
//  local_sin.sin_addr.s_addr = htonl (INADDR_ANY);

if ((phostent = gethostbyname ("192.168.100.100")) == NULL)  {
	return	FALSE;
}

//if ((phostent = gethostbyname ("172.16.1.24")) == NULL)  {
//	return	FALSE;
//}


// Assign the socket IP address.
memcpy ((char FAR *)&(local_sin.sin_addr), phostent->h_addr, phostent->h_length);


// Associate the local address with WinSocket.
if (bind (WinSocket, 
            (struct sockaddr *) &local_sin, 
            sizeof (local_sin)) == SOCKET_ERROR) 
  {
    wsprintf (szError, TEXT("Binding socket failed. Error: %d"), 
              WSAGetLastError ());
    m_Dlg->MessageBox (szError, TEXT("Error"), MB_OK);
    closesocket (WinSocket);
    return FALSE;
  }

  // Establish a socket to listen for incoming connections.
  if (listen (WinSocket, MAX_PENDING_CONNECTS) == SOCKET_ERROR) 
  {
    wsprintf (szError, 
              TEXT("Listening to the client failed. Error: %d"),
              WSAGetLastError ());
    m_Dlg->MessageBox(szError, TEXT("Error"), MB_OK);
    closesocket (WinSocket);
    return FALSE;
  }

accept_sin_len = sizeof (accept_sin);



	
while(1) {
	WaitForSingleObject(m_Dlg->s_DoEvent,INFINITE);

	if  ( TreatStatusServ == FALSE )	break;


	// Accept an incoming connection attempt on WinSocket.
	ClientSock = accept (WinSocket, (struct sockaddr *) &accept_sin, (int *) &accept_sin_len);

	// Stop listening for connections from clients.
	//closesocket (WinSocket);

	if (ClientSock == INVALID_SOCKET)  {
		wsprintf (szError, TEXT("Accepting connection with client failed.")
              TEXT(" Error: %d"), WSAGetLastError ());
		m_Dlg->MessageBox(szError, TEXT("Error"), MB_OK);
		continue;
	}

	pimage = &image[0];
	efisTransmitImage(TYPESCANNER_EFIS120, ClientSock, (unsigned char *)pimage);

	memmove(m_Dlg->pimg, image, 280*440);

	m_Dlg->MyPaint();


	efisCloseConnection(ClientSock);

	// Disable both sending and receiving on ClientSock.
	shutdown (ClientSock, 0x02 );

	// Close ClientSock.
	closesocket (ClientSock);
}
return	0;
}




