// winefisconDlg.cpp : implementation file
//

#include "stdafx.h"
#include <io.h>
#include <fcntl.h>
#include "winefiscon.h"
#include "winefisconDlg.h"
#include "erel11xc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinefisconDlg dialog

CWinefisconDlg::CWinefisconDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWinefisconDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWinefisconDlg)
	//m_delay_green = 0;
	//m_delay_red = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	
	m_access_serv = -1;
	m_access_cal  = -1;
	m_access_dhcp = -1;
	m_access_toggle = 0;


}

void CWinefisconDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWinefisconDlg)
	DDX_Control(pDX, IDC_LISTCAL, m_listcal);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWinefisconDlg, CDialog)
	//{{AFX_MSG_MAP(CWinefisconDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_READ, OnRead)
	ON_BN_CLICKED(IDC_WRITE, OnWrite)
	ON_BN_CLICKED(IDC_DHCP1, OnDhcpYes)
	ON_BN_CLICKED(IDC_DHCP2, OnDchpNo)
	ON_BN_CLICKED(IDC_REBOOT, OnReboot)
	ON_BN_CLICKED(IDC_CALENDAR, OnCalendar)
	ON_BN_CLICKED(IDC_TOGGLES, OnToggles)
	ON_BN_CLICKED(IDC_EVENT_TO_SERVER, OnEventToServer)
	ON_BN_CLICKED(IDC_R1_MOD1, OnR1Mod1)
	ON_BN_CLICKED(IDC_R1_MOD2, OnR1Mod2)
	ON_BN_CLICKED(IDC_R1_MOD3, OnR1Mod3)
	ON_BN_CLICKED(IDC_R1_MOD4, OnR1Mod4)
	ON_BN_CLICKED(IDC_R1_MOD5, OnR1Mod5)
	ON_BN_CLICKED(IDC_R2_MOD1, OnR2Mod1)
	ON_BN_CLICKED(IDC_R2_MOD2, OnR2Mod2)
	ON_BN_CLICKED(IDC_R2_MOD3, OnR2Mod3)
	ON_BN_CLICKED(IDC_R2_MOD4, OnR2Mod4)
	ON_BN_CLICKED(IDC_R2_MOD5, OnR2Mod5)
	ON_BN_CLICKED(IDC_R3_MOD1, OnR3Mod1)
	ON_BN_CLICKED(IDC_R3_MOD2, OnR3Mod2)
	ON_BN_CLICKED(IDC_R3_MOD3, OnR3Mod3)
	ON_BN_CLICKED(IDC_R3_MOD4, OnR3Mod4)
	ON_BN_CLICKED(IDC_R3_MOD5, OnR3Mod5)
	ON_BN_CLICKED(IDC_R4_MOD1, OnR4Mod1)
	ON_BN_CLICKED(IDC_R4_MOD2, OnR4Mod2)
	ON_BN_CLICKED(IDC_R4_MOD3, OnR4Mod3)
	ON_BN_CLICKED(IDC_R4_MOD4, OnR4Mod4)
	ON_BN_CLICKED(IDC_R4_MOD5, OnR4Mod5)
	ON_BN_CLICKED(IDC_INPTOG, OnInptog)
	ON_BN_CLICKED(IDC_SETREL1, OnSetrel1)
	ON_BN_CLICKED(IDC_SETREL2, OnSetrel2)
	ON_BN_CLICKED(IDC_SETREL3, OnSetrel3)
	ON_BN_CLICKED(IDC_SETREL4, OnSetrel4)
	ON_BN_CLICKED(IDC_CALNUPD, OnCalnupd)
	ON_BN_CLICKED(IDC_CALNCLR, OnCalnclr)
	ON_NOTIFY(NM_CLICK, IDC_LISTCAL, OnClickListcal)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinefisconDlg message handlers

BOOL CWinefisconDlg::OnInitDialog()
{
	int	w;
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	strcpy(ipaddress,"192.168.100.5");
	strcpy(ipport,"5000");

	SetDlgItemText(IDC_CONNECTIP,ipaddress);
	SetDlgItemText(IDC_CONNECTPORT,ipport);
	//SetDlgItemText(IDC_NAMEFIRM,"testv4s.hex");

	CheckRadioButton(IDC_R1_MOD1, IDC_R1_MOD5, IDC_R1_MOD1); mode_relay1 = 1;
	CheckRadioButton(IDC_R2_MOD1, IDC_R2_MOD5, IDC_R2_MOD1); mode_relay2 = 1;
	CheckRadioButton(IDC_R3_MOD1, IDC_R3_MOD5, IDC_R3_MOD1); mode_relay3 = 1;
	CheckRadioButton(IDC_R4_MOD1, IDC_R4_MOD5, IDC_R4_MOD1); mode_relay4 = 1;

	CWnd* pWnd = GetDlgItem(IDC_LISTCAL);
	
	CRect rect;
	pWnd->GetWindowRect(&rect);

	w = rect.Width();

	w = w - 300;
	
	m_listcal.InsertColumn(0, _T("N"),		LVCFMT_LEFT,  30);
	m_listcal.InsertColumn(1, _T("Type"),	LVCFMT_LEFT,  30);
	m_listcal.InsertColumn(2, _T("N Rel"),	LVCFMT_LEFT,  40);
	m_listcal.InsertColumn(3, _T("Hour"),	LVCFMT_LEFT,  35);
	m_listcal.InsertColumn(4, _T("Min"),	LVCFMT_LEFT,  30);
	m_listcal.InsertColumn(5, _T("Sec"),	LVCFMT_LEFT,  35);

	m_listcal.InsertColumn(6, _T("Hour"),	LVCFMT_LEFT,  35);
	m_listcal.InsertColumn(7, _T("Min"),	LVCFMT_LEFT,  30);
	m_listcal.InsertColumn(8, _T("Sec"),	LVCFMT_LEFT,  35);

	m_listcal.InsertColumn(9, _T("Day"),	LVCFMT_LEFT,  w/6);
	m_listcal.InsertColumn(10, _T("Mon"),	LVCFMT_LEFT,  w/6);
	m_listcal.InsertColumn(11,_T("Year"),   LVCFMT_LEFT,  w/6);
	m_listcal.InsertColumn(12,_T("Day"),	LVCFMT_LEFT,  w/6);
	m_listcal.InsertColumn(13,_T("Mon"),	LVCFMT_LEFT,  w/6);
	m_listcal.InsertColumn(14,_T("Year"),   LVCFMT_LEFT,  w/6);

	ListView_SetExtendedListViewStyle( m_listcal, LVS_EX_FULLROWSELECT);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWinefisconDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWinefisconDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWinefisconDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


/*
*/
unsigned short Transposition2x8(unsigned short val)	
{
unsigned short	v;

v = val;

v = v << 8;
v = v & 0xff00;
v = v | ((val >> 8)&0x00ff);

return	v;
}



char CV(char c)
{

if ( c >= '0' && c <= '9' ) 	return c - '0';
if ( c >= 'A' && c <= 'F' ) 	return c - 'A' + 10;
if ( c >= 'a' && c <= 'f' ) 	return c - 'a' + 10;
}


unsigned char ATOI(char * s)
{
unsigned char v = 0;
int	i = 0;

while(1) {
	if ( s[i] == 0 )	break;
	v = v << 4;
	v = v | CV(s[i]);
	i++;
}

return	v;
}


void	ConvAddressX(unsigned char * param, char * address, int num)
{
char	* seps = ".:";
char *token;
int	i = 0;


token = strtok(address,seps);
if ( token == NULL )	return;
param[i] = (unsigned char)ATOI(token);
i++;

while( 1 ) {
      /* Get next token: */
      token = strtok( NULL, seps );
	  if ( token == NULL )	break;
	  param[i] = (unsigned char)ATOI(token);
	  i++;
	  if ( i == num )	break;
 
}
}

void	ConvAddressI(unsigned char * param, char * address, int num)
{
char	* seps = ".:";
char *token;
int	i = 0;


token = strtok(address,seps);
if ( token == NULL )	return;
param[i] = (unsigned char)atoi(token);
i++;

while( 1 ) {
      /* Get next token: */
      token = strtok( NULL, seps );
	  if ( token == NULL )	break;
	  param[i] = (unsigned char)atoi(token);
	  i++;
	  if ( i == num )	break;
 
}
}


void CWinefisconDlg::OnConnect() 
{
	// TODO: Add your control notification handler code here
unsigned char ver[16];
char txtver[32], bb[16];
int	port;
CString	str;

GetDlgItemText(IDC_CONNECTIP,str);
port = GetDlgItemInt(IDC_CONNECTPORT);


handle = -1;

if ( (handle = erelOpenDevice(TYPEDEVICE_EREL112, (unsigned char *)str.GetBuffer(0),port)) == rcOK ) {
//	MessageBox("Connected");
//	SetDlgItemText(IDC_MAC,"");
//	SetDlgItemText(IDC_IPADDRESS_GW,"");
}
else { 
	handle = -1;
	MessageBox("No Connect");
	return;
}

//GetDlgItem(IDC_CONNECT)->EnableWindow(FALSE);
//GetDlgItem(IDC_READ)->EnableWindow(TRUE);
//GetDlgItem(IDC_WRITE)->EnableWindow(TRUE);
//GetDlgItem(IDC_DISCONNECT)->EnableWindow(TRUE);
//GetDlgItem(IDC_UPDATE)->EnableWindow(TRUE);
}

void CWinefisconDlg::OnDisconnect() 
{
	// TODO: Add your control notification handler code here
if ( handle != -1 )	 {
	erelCloseDevice(handle);
	handle = -1;
}
//GetDlgItem(IDC_CONNECT)->EnableWindow(TRUE);
//GetDlgItem(IDC_READ)->EnableWindow(FALSE);
//GetDlgItem(IDC_WRITE)->EnableWindow(FALSE);
//GetDlgItem(IDC_DISCONNECT)->EnableWindow(FALSE);
//GetDlgItem(IDC_UPDATE)->EnableWindow(FALSE);
}

void CWinefisconDlg::OnRead() 
{
unsigned char	* param, bcon[1024];
char	buf[20], out[1024];
int	i, size_cl;
// TODO: Add your control notification handler code here

size_cl = 10*sizeof(Calendar);

OnConnect();
if ( handle == -1 )	return;

param = &bcon[0];
Sleep(500);

if ( erelGetVersion(handle,param) == rcOK ) {
	strcpy(out, "ver:");
	sprintf(buf,  "%02d",param[0]);
	sprintf(buf+2,"%02d",param[1]);
	sprintf(buf+4,"%02d",param[2]);
	sprintf(buf+6,"%02d",param[3]);
	strcat(out,buf);
	strcat(out,"/");

	sprintf(buf,  "%d",param[4]);
	strcat(out,buf);
	strcat(out,"/");
	sprintf(buf,  "%d",param[5]);
	strcat(out,buf);
	strcat(out,"/");
	sprintf(buf,    "%02d",param[6]);
	sprintf(buf+2,  "%02d",param[7]);
	strcat(out,buf);

	SetDlgItemText(IDC_VER, out);
}
else {
	SetDlgItemText(IDC_VER, "                 ");
}

if ( erelGetParamX(handle, bcon) != rcOK ) {
	OnDisconnect();
	return;
}

param++;

if ( param[0] == 255 && param[1] == 255 && param[2] == 255 && param[3] == 255 && param[4] == 255 && param[5] == 255 ) {
	param[0] = 0;
	param[1] = 0;
	param[2] = 0x7;
	param[3] = 0xdc;
	param[4] = 0;
	param[5] = 0;

	param[6] = 192;
	param[7] = 168;
	param[8] = 100;
	param[9] = 2;

	param[10] = 255;
	param[11] = 255;
	param[12] = 255;
	param[13] = 0;

	param[14] = 192;
	param[15] = 168;
	param[16] = 100;
	param[17] = 1;

	param[18] = 192;
	param[19] = 168;
	param[20] = 100;
	param[21] = 255;

	*(short *)(param+22) = Transposition2x8(5000);

	param[24] = 192;
	param[25] = 168;
	param[26] = 100;
	param[27] = 100;

	*(short *)(param+28) = Transposition2x8(3000);

	param[30] = 0;	//	dhcp
	param[31] = 114;	//	device type

	*(short *)(param+32) = Transposition2x8(0);	//	device ID

	param[34] = 0;	//	access to server

	param[35] = 0;

		
	strnset((char *)(param + 36), 0, 256);

	*(byte *)(param + 42 + size_cl) = 1; 
	*(byte *)(param + 43 + size_cl) = 1;
	*(byte *)(param + 44 + size_cl) = 1; 
	*(byte *)(param + 45 + size_cl) = 1;

	m_access_dhcp = -1;
	m_access_serv = -1;
	m_access_cal  = -1;
	m_access_toggle = 0;
	m_inputs_as_toggle = 0;

}

sprintf(buf, "%x:",	param[0]);
strcpy(out, buf);
sprintf(buf, "%x:",	param[1]);
strcat(out, buf);
sprintf(buf, "%x:",	param[2]);
strcat(out, buf);
sprintf(buf, "%x:",	param[3]);
strcat(out, buf);
sprintf(buf, "%x:",	param[4]);
strcat(out, buf);
sprintf(buf, "%x\0",param[5]);
strcat(out, buf);

SetDlgItemText(IDC_MAC,out);

sprintf(buf, "%d.",	param[6]);
strcpy(out, buf);
sprintf(buf, "%d.",	param[7]);
strcat(out, buf);
sprintf(buf, "%d.",	param[8]);
strcat(out, buf);
sprintf(buf, "%d\0",param[9]);
strcat(out, buf);

SetDlgItemText(IDC_IPADDRESS1,out);

sprintf(buf, "%d.",	param[10]);
strcpy(out, buf);
sprintf(buf, "%d.",	param[11]);
strcat(out, buf);
sprintf(buf, "%d.",	param[12]);
strcat(out, buf);
sprintf(buf, "%d\0",param[13]);
strcat(out, buf);

SetDlgItemText(IDC_IPADDRESS_MASK,out);

sprintf(buf, "%d.",	param[14]);
strcpy(out, buf);
sprintf(buf, "%d.",	param[15]);
strcat(out, buf);
sprintf(buf, "%d.",	param[16]);
strcat(out, buf);
sprintf(buf, "%d\0",param[17]);
strcat(out, buf);

SetDlgItemText(IDC_IPADDRESS_GW,out);

;
SetDlgItemInt(IDC_PORT, Transposition2x8(*(short *)(param+22)));

sprintf(buf, "%d.",	param[24]);
strcpy(out, buf);
sprintf(buf, "%d.",	param[25]);
strcat(out, buf);
sprintf(buf, "%d.",	param[26]);
strcat(out, buf);
sprintf(buf, "%d\0",param[27]);
strcat(out, buf);

SetDlgItemText(IDC_IPADDRESS_SERVER,out);

SetDlgItemInt(IDC_PORT_SERVER, Transposition2x8(*(short *)(param+28)));


if ( param[30] == 1 ) {
	CheckRadioButton(IDC_DHCP1, IDC_DHCP2, IDC_DHCP1); 
	m_access_dhcp = 1;
}
else {
	CheckRadioButton(IDC_DHCP1, IDC_DHCP2, IDC_DHCP2); 
	m_access_dhcp = 0;
}

SetDlgItemInt(IDC_TYPEDEVICE, param[31] );	//	type of device

SetDlgItemInt(IDC_DEVICEID, Transposition2x8(*(short *)(param+32)));

m_access_serv = 0;
CheckDlgButton(IDC_EVENT_TO_SERVER, m_access_serv);

if ( param[35] == 1 ) {
	m_access_cal = 1;
	CheckDlgButton(IDC_CALENDAR, m_access_cal);
}
else {
	m_access_cal = 0;
	CheckDlgButton(IDC_CALENDAR, m_access_cal);
}

m_listcal.DeleteAllItems();
ASSERT(m_listcal.GetItemCount() == 0);

for(i = 0; i < 10; i++) {
	cl = *(Calendar *)(param + 36 + i*sizeof(Calendar));

	m_listcal.InsertItem( i, " ");
	
	sprintf(buf,"%d", i+1);
	m_listcal.SetItemText( i, 0, buf);

	sprintf(buf,"%d", cl.type);
	m_listcal.SetItemText( i, 1, buf);
	sprintf(buf,"%d", cl.relay);
	m_listcal.SetItemText( i, 2, buf);

		
	sprintf(buf,"%d", cl.hour_on);
	m_listcal.SetItemText( i, 3, buf);
	sprintf(buf,"%d", cl.min_on);
	m_listcal.SetItemText( i, 4, buf);
	sprintf(buf,"%d", cl.sec_on);
	m_listcal.SetItemText( i, 5, buf);

	sprintf(buf,"%d", cl.hour_off);
	m_listcal.SetItemText( i, 6, buf);
	sprintf(buf,"%d", cl.min_off);
	m_listcal.SetItemText( i, 7, buf);
	sprintf(buf,"%d", cl.sec_off);
	m_listcal.SetItemText( i, 8, buf);

	sprintf(buf,"%d", cl.day_on);
	m_listcal.SetItemText( i, 9, buf);
	sprintf(buf,"%d", cl.mon_on);
	m_listcal.SetItemText( i, 10, buf);
	sprintf(buf,"%d", cl.year_on);
	m_listcal.SetItemText( i, 11, buf);

	sprintf(buf,"%d", cl.day_off);
	m_listcal.SetItemText( i, 12, buf);
	sprintf(buf,"%d", cl.mon_off);
	m_listcal.SetItemText( i, 13, buf);
	sprintf(buf,"%d", cl.year_off);
	m_listcal.SetItemText( i, 14, buf);
}

m_access_toggle = *(unsigned char *)(param + 36 + size_cl);
CheckDlgButton(IDC_TOGGLES, m_access_toggle);

m_inputs_as_toggle = *(unsigned char *)(param + 37 + size_cl);
CheckDlgButton(IDC_INPTOG, m_inputs_as_toggle);

m_setup_relay1 = *(unsigned char *)(param + 38 + size_cl);
CheckDlgButton(IDC_SETREL1, m_setup_relay1);

m_setup_relay2 = *(unsigned char *)(param + 39 + size_cl);
CheckDlgButton(IDC_SETREL2, m_setup_relay2);

m_setup_relay3 = *(unsigned char *)(param + 40 + size_cl);
CheckDlgButton(IDC_SETREL3, m_setup_relay3);

m_setup_relay4 = *(unsigned char *)(param + 41 + size_cl);
CheckDlgButton(IDC_SETREL4, m_setup_relay4);

mode_relay1 = *(byte *)(param + 42 + size_cl);
mode_relay2 = *(byte *)(param + 43 + size_cl);
mode_relay3 = *(byte *)(param + 44 + size_cl);
mode_relay4 = *(byte *)(param + 45 + size_cl);

SetDlgItemInt(IDC_DREL1, *(unsigned char *)(param + 46 + size_cl));
SetDlgItemInt(IDC_DREL2, *(unsigned char *)(param + 47 + size_cl));
SetDlgItemInt(IDC_DREL3, *(unsigned char *)(param + 48 + size_cl));
SetDlgItemInt(IDC_DREL4, *(unsigned char *)(param + 49 + size_cl));

if (mode_relay1 == 1 ) {
	CheckRadioButton(IDC_R1_MOD1, IDC_R1_MOD5, IDC_R1_MOD1); 
}
if (mode_relay1 == 2 ) {
	CheckRadioButton(IDC_R1_MOD1, IDC_R1_MOD5, IDC_R1_MOD2); 
}
if (mode_relay1 == 3 ) {
	CheckRadioButton(IDC_R1_MOD1, IDC_R1_MOD5, IDC_R1_MOD3); 
}
if (mode_relay1 == 4 ) {
	CheckRadioButton(IDC_R1_MOD1, IDC_R1_MOD5, IDC_R1_MOD4); 
}
if (mode_relay1 == 5 ) {
	CheckRadioButton(IDC_R1_MOD1, IDC_R1_MOD5, IDC_R1_MOD5); 
}

//---
if (mode_relay2 == 1 ) {
	CheckRadioButton(IDC_R2_MOD1, IDC_R2_MOD5, IDC_R2_MOD1); 
}
if (mode_relay2 == 2 ) {
	CheckRadioButton(IDC_R2_MOD1, IDC_R2_MOD5, IDC_R2_MOD2); 
}
if (mode_relay2 == 3 ) {
	CheckRadioButton(IDC_R2_MOD1, IDC_R2_MOD5, IDC_R2_MOD3); 
}
if (mode_relay2 == 4 ) {
	CheckRadioButton(IDC_R2_MOD1, IDC_R2_MOD5, IDC_R2_MOD4); 
}
if (mode_relay2 == 5 ) {
	CheckRadioButton(IDC_R2_MOD1, IDC_R2_MOD5, IDC_R2_MOD5); 
}

//---
if (mode_relay3 == 1 ) {
	CheckRadioButton(IDC_R3_MOD1, IDC_R3_MOD5, IDC_R3_MOD1); 
}
if (mode_relay3 == 2 ) {
	CheckRadioButton(IDC_R3_MOD1, IDC_R3_MOD5, IDC_R3_MOD2); 
}
if (mode_relay3 == 3 ) {
	CheckRadioButton(IDC_R3_MOD1, IDC_R3_MOD5, IDC_R3_MOD3); 
}
if (mode_relay3 == 4 ) {
	CheckRadioButton(IDC_R3_MOD1, IDC_R3_MOD5, IDC_R3_MOD4); 
}
if (mode_relay3 == 5 ) {
	CheckRadioButton(IDC_R3_MOD1, IDC_R3_MOD5, IDC_R3_MOD5); 
}

//---
if (mode_relay4 == 1 ) {
	CheckRadioButton(IDC_R4_MOD1, IDC_R4_MOD5, IDC_R4_MOD1); 
}
if (mode_relay4 == 2 ) {
	CheckRadioButton(IDC_R4_MOD1, IDC_R4_MOD5, IDC_R4_MOD2); 
}
if (mode_relay4 == 3 ) {
	CheckRadioButton(IDC_R4_MOD1, IDC_R4_MOD5, IDC_R4_MOD3); 
}
if (mode_relay4 == 4 ) {
	CheckRadioButton(IDC_R4_MOD1, IDC_R4_MOD5, IDC_R4_MOD4); 
}
if (mode_relay4 == 5 ) {
	CheckRadioButton(IDC_R4_MOD1, IDC_R4_MOD5, IDC_R4_MOD5); 
}

if ( GetDlgItemInt(IDC_TYPEDEVICE) != 114 ) {
	GetDlgItem(IDC_TOGGLES)->EnableWindow(FALSE);
	GetDlgItem(IDC_INPTOG)->EnableWindow(FALSE);
	DisableToggle();
	m_access_toggle = 0;
	m_inputs_as_toggle = 0;
}
else {
	GetDlgItem(IDC_TOGGLES)->EnableWindow(TRUE);
	GetDlgItem(IDC_INPTOG)->EnableWindow(TRUE);
	EnableToggle();
}

if ( m_access_toggle == 0 && m_inputs_as_toggle == 0 ) {
	DisableToggle();
}
else {
	EnableToggle();
}

if ( m_access_cal == 0 ) {
	GetDlgItem(IDC_CALNUPD)->EnableWindow(FALSE);
	GetDlgItem(IDC_CALNCLR)->EnableWindow(FALSE);
}
else {
	GetDlgItem(IDC_CALNUPD)->EnableWindow(TRUE);
	GetDlgItem(IDC_CALNCLR)->EnableWindow(TRUE);
}

OnDisconnect();

GetDlgItem(IDC_WRITE)->EnableWindow(TRUE);
}


void CWinefisconDlg::OnWrite() 
{
unsigned char * param;
unsigned char	bcon[1024];

param = &bcon[1];

CString	str;
short	i, port, size_cl;
unsigned short val;

size_cl = 10*sizeof(Calendar);

// ????
m_access_serv = 0;

//GetDlgItemText(IDC_IPADDRESS1,str);
//port = GetDlgItemInt(IDC_PORT);

if ( m_access_dhcp == -1 ) {
	MessageBox("No define DHCP service");
	return;
}

if ( m_access_cal == -1 ) {
	MessageBox("No define calendar service");
	return;
}

if ( m_access_cal != 0 ) {
	if ( m_access_toggle != 0 || m_inputs_as_toggle != 0 ) {
		MessageBox("The toggles service is not compatible with calendar");
		return;
	}

}


OnConnect();
if ( handle == -1 )	return;


for(i = 0; i < 512; i++)	param[i] = 0;

// TODO: Add your control notification handler code here

GetDlgItemText(IDC_MAC,str);
ConvAddressX(param, str.GetBuffer(0), 6);

GetDlgItemText(IDC_IPADDRESS1,str);				
ConvAddressI(param+6, str.GetBuffer(0), 4);

port = GetDlgItemInt(IDC_PORT);
port = Transposition2x8(port);
*(short *)(param+22) = port;

GetDlgItemText(IDC_IPADDRESS_MASK,str);				
ConvAddressI(param+10, str.GetBuffer(0), 4);

GetDlgItemText(IDC_IPADDRESS_GW,str);				
ConvAddressI(param+14, str.GetBuffer(0), 4);


GetDlgItemText(IDC_IPADDRESS_SERVER,str);				
ConvAddressI(param+24, str.GetBuffer(0), 4);

port = GetDlgItemInt(IDC_PORT_SERVER);
port = Transposition2x8(port);
*(short *)(param+28) = port;

*(byte *)(param+30) = m_access_dhcp;
*(byte *)(param+31) = GetDlgItemInt(IDC_TYPEDEVICE);

port = GetDlgItemInt(IDC_DEVICEID);
port = Transposition2x8(port);
*(short *)(param+32) = port;

*(byte *)(param+34) = m_access_serv;
/* */
*(byte *)(param+35) = m_access_cal;

for(i = 0; i < 10; i++) {


		cl.hour_on = 0;  
		cl.min_on = 0;	    
		cl.sec_on = 0;	    

		cl.hour_off = 0;	  
		cl.min_off = 0;	  
		cl.sec_off = 0;	  
	
		cl.day_on = 0;     
		cl.mon_on = 0;     
		cl.year_on = 0;   

		cl.day_off = 0;    
		cl.mon_off = 0;    
		cl.year_off = 0;  

		str = m_listcal.GetItemText( i, 1);
		cl.type = atoi(str.GetBuffer(0));

		str = m_listcal.GetItemText( i, 2);
		cl.relay = atoi(str.GetBuffer(0));

		str = m_listcal.GetItemText( i, 3);
		cl.hour_on = atoi(str.GetBuffer(0));
		str = m_listcal.GetItemText( i, 4);
		cl.min_on = atoi(str.GetBuffer(0));
		str = m_listcal.GetItemText( i, 5);
		cl.sec_on = atoi(str.GetBuffer(0));

		str = m_listcal.GetItemText( i, 6);
		cl.hour_off = atoi(str.GetBuffer(0));
		str = m_listcal.GetItemText( i, 7);
		cl.min_off = atoi(str.GetBuffer(0));
		str = m_listcal.GetItemText( i, 8);
		cl.sec_off = atoi(str.GetBuffer(0));


		str = m_listcal.GetItemText( i, 9);
		cl.day_on = atoi(str.GetBuffer(0));
		str = m_listcal.GetItemText( i, 10);
		cl.mon_on = atoi(str.GetBuffer(0));
		str = m_listcal.GetItemText( i, 11);
		cl.year_on = atoi(str.GetBuffer(0));

		str = m_listcal.GetItemText( i, 12);
		cl.day_off = atoi(str.GetBuffer(0));
		str = m_listcal.GetItemText( i, 13);
		cl.mon_off = atoi(str.GetBuffer(0));
		str = m_listcal.GetItemText( i, 14);
		cl.year_off = atoi(str.GetBuffer(0));

		*(Calendar *)(param + 36 + i*sizeof(Calendar)) = cl;
}


if (  GetDlgItemInt(IDC_TYPEDEVICE) != 114 ) {
	m_access_toggle = 0;
	m_inputs_as_toggle = 0;
}


*(byte *)(param + 36 + size_cl) = m_access_toggle;
*(byte *)(param + 37 + size_cl) = m_inputs_as_toggle;


*(byte *)(param + 38 + size_cl) = m_setup_relay1;
*(byte *)(param + 39 + size_cl) = m_setup_relay2;
*(byte *)(param + 40 + size_cl) = m_setup_relay3;
*(byte *)(param + 41 + size_cl) = m_setup_relay4;


*(byte *)(param + 42 + size_cl) = mode_relay1;
*(byte *)(param + 43 + size_cl) = mode_relay2;
*(byte *)(param + 44 + size_cl) = mode_relay3;
*(byte *)(param + 45 + size_cl) = mode_relay4;


*(byte *)(param + 46 + size_cl) = GetDlgItemInt(IDC_DREL1);
*(byte *)(param + 47 + size_cl) = GetDlgItemInt(IDC_DREL2);
*(byte *)(param + 48 + size_cl) = GetDlgItemInt(IDC_DREL3);
*(byte *)(param + 49 + size_cl) = GetDlgItemInt(IDC_DREL4);


bcon[0] = 0x1A;

erelSetParamX(handle, bcon);

OnDisconnect();

GetDlgItem(IDC_WRITE)->EnableWindow(FALSE);
GetDlgItem(IDC_CALNUPD)->EnableWindow(FALSE);
GetDlgItem(IDC_CALNCLR)->EnableWindow(FALSE);
}

/*
*/
void CWinefisconDlg::OnDhcpYes() 
{
	// TODO: Add your control notification handler code here
	m_access_dhcp = 1;	
	
}

void CWinefisconDlg::OnDchpNo() 
{
	// TODO: Add your control notification handler code here
	m_access_dhcp = 0;	
	
}


void CWinefisconDlg::OnReboot() 
{
	OnConnect();
	if ( handle == -1 )	return;

	// TODO: Add your control notification handler code here
	erelReboot(handle);

	OnDisconnect();
}


void CWinefisconDlg::OnEventYes() 
{
	// TODO: Add your control notification handler code here
	m_access_serv = 1;	
}


void CWinefisconDlg::OnEventNo() 
{
	// TODO: Add your control notification handler code here
	m_access_serv = 0;	
}

void CWinefisconDlg::OnCal1() 
{
	// TODO: Add your control notification handler code here
	m_access_cal = 1;	
	
}

void CWinefisconDlg::OnCal2() 
{
	// TODO: Add your control notification handler code here
	m_access_cal = 0;	
	
}

void CWinefisconDlg::OnCalendar() 
{
	// TODO: Add your control notification handler code here
	m_access_cal = IsDlgButtonChecked(IDC_CALENDAR);

	if ( m_access_cal == 0 ) {
		GetDlgItem(IDC_CALNUPD)->EnableWindow(FALSE);
		GetDlgItem(IDC_CALNCLR)->EnableWindow(FALSE);
	}
	else {
		GetDlgItem(IDC_CALNUPD)->EnableWindow(TRUE);
		GetDlgItem(IDC_CALNCLR)->EnableWindow(TRUE);
	}
}

void CWinefisconDlg::OnToggles() 
{
	// TODO: Add your control notification handler code here
	m_access_toggle = IsDlgButtonChecked(IDC_TOGGLES);
	m_inputs_as_toggle = IsDlgButtonChecked(IDC_INPTOG);
	if ( m_access_toggle == 0 && m_inputs_as_toggle == 0 ) {
		DisableToggle();
	}
	else {
		EnableToggle();
	}	
}

void CWinefisconDlg::OnEventToServer() 
{
	// TODO: Add your control notification handler code here
	m_access_serv = 0;	
}

void CWinefisconDlg::OnR1Mod1() 
{
	// TODO: Add your control notification handler code here
	mode_relay1 = 1;
}

void CWinefisconDlg::OnR1Mod2() 
{
	// TODO: Add your control notification handler code here
	mode_relay1 = 2;
}

void CWinefisconDlg::OnR1Mod3() 
{
	// TODO: Add your control notification handler code here
	mode_relay1 = 3;
}

void CWinefisconDlg::OnR1Mod4() 
{
	// TODO: Add your control notification handler code here
	mode_relay1 = 4;
}

void CWinefisconDlg::OnR1Mod5() 
{
	// TODO: Add your control notification handler code here
	mode_relay1 = 5;
}

void CWinefisconDlg::OnR2Mod1() 
{
	// TODO: Add your control notification handler code here
	mode_relay2 = 1;
}

void CWinefisconDlg::OnR2Mod2() 
{
	// TODO: Add your control notification handler code here
	mode_relay2 = 2;	
}

void CWinefisconDlg::OnR2Mod3() 
{
	// TODO: Add your control notification handler code here
	mode_relay2 = 3;
}

void CWinefisconDlg::OnR2Mod4() 
{
	// TODO: Add your control notification handler code here
	mode_relay2 = 4;	
}

void CWinefisconDlg::OnR2Mod5() 
{
	// TODO: Add your control notification handler code here
	mode_relay2 = 5;	
}

void CWinefisconDlg::OnR3Mod1() 
{
	// TODO: Add your control notification handler code here
	mode_relay3 = 1;
}

void CWinefisconDlg::OnR3Mod2() 
{
	// TODO: Add your control notification handler code here
	mode_relay3 = 2;	
}

void CWinefisconDlg::OnR3Mod3() 
{
	// TODO: Add your control notification handler code here
	mode_relay3 = 3;	
}

void CWinefisconDlg::OnR3Mod4() 
{
	// TODO: Add your control notification handler code here
	mode_relay3 = 4;
}

void CWinefisconDlg::OnR3Mod5() 
{
	// TODO: Add your control notification handler code here
	mode_relay3 = 5;	
}

void CWinefisconDlg::OnR4Mod1() 
{
	// TODO: Add your control notification handler code here
	mode_relay4 = 1;	
}

void CWinefisconDlg::OnR4Mod2() 
{
	// TODO: Add your control notification handler code here
	mode_relay4 = 2;
}

void CWinefisconDlg::OnR4Mod3() 
{
	// TODO: Add your control notification handler code here
	mode_relay4 = 3;	
}


void CWinefisconDlg::OnR4Mod4() 
{
	// TODO: Add your control notification handler code here
	mode_relay4 = 4;
}

void CWinefisconDlg::OnR4Mod5() 
{
	// TODO: Add your control notification handler code here
	mode_relay4 = 5;	
}

void CWinefisconDlg::OnInptog() 
{
	// TODO: Add your control notification handler code here
	m_access_toggle = IsDlgButtonChecked(IDC_TOGGLES);
	m_inputs_as_toggle = IsDlgButtonChecked(IDC_INPTOG);
	if ( m_access_toggle == 0 && m_inputs_as_toggle == 0 ) {
		DisableToggle();
	}
	else {
		EnableToggle();
	}	
}

void CWinefisconDlg::OnSetrel1() 
{
	// TODO: Add your control notification handler code here
	m_setup_relay1 = IsDlgButtonChecked(IDC_SETREL1);	
}

void CWinefisconDlg::OnSetrel2() 
{
	// TODO: Add your control notification handler code here
	m_setup_relay2 = IsDlgButtonChecked(IDC_SETREL2);	
}

void CWinefisconDlg::OnSetrel3() 
{
	// TODO: Add your control notification handler code here
	m_setup_relay3 = IsDlgButtonChecked(IDC_SETREL3);	
}

void CWinefisconDlg::OnSetrel4() 
{
	// TODO: Add your control notification handler code here
	m_setup_relay4 = IsDlgButtonChecked(IDC_SETREL4);
}





void CWinefisconDlg::OnCalnupd() 
{
	// TODO: Add your control notification handler code here
	int	r, rel_type;

	if ( current_row == -1 )	{
		MessageBox("The user isn't selected", "Modify", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		return;
	}
	if ( status_click == 0 ) {
		MessageBox("Please, select line by mouse", "Modify", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		return;
	}

	// TODO: Add your control notification handler code here

	//	check all parametrs
	r = GetDlgItemInt(IDC_T1);
	if ( r < 1 || r > 13 ) {
		MessageBox("The type of calender isn't correct", "Modify", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		(CEdit *)GetDlgItem(IDC_T1)->SetFocus();
		((CEdit *)GetDlgItem(IDC_T1))->SetSel(0,-1);
		return;
	}


	rel_type = GetDlgItemInt(IDC_TYPEDEVICE);
	if ( rel_type != 112 && rel_type != 123 && rel_type != 114 ) {
		MessageBox("The type of device isn't correct", "Modify", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		(CEdit *)GetDlgItem(IDC_TYPEDEVICE)->SetFocus();
		((CEdit *)GetDlgItem(IDC_TYPEDEVICE))->SetSel(0,-1);
		return;
	}
	
	r = GetDlgItemInt(IDC_REL1);

	if ( rel_type == 112 ) {
		if ( r < 1 || r > 2 ) {
			MessageBox("The number of relay isn't correct", "Modify", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
			(CEdit *)GetDlgItem(IDC_REL1)->SetFocus();
			((CEdit *)GetDlgItem(IDC_REL1))->SetSel(0,-1);
			return;
		}
	}
	if ( rel_type == 123 ) {
		if ( r < 1 || r > 3 ) {
			MessageBox("The number of relay isn't correct", "Modify", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
			(CEdit *)GetDlgItem(IDC_REL1)->SetFocus();
			((CEdit *)GetDlgItem(IDC_REL1))->SetSel(0,-1);
			return;
		}
	}
	if ( rel_type == 114 ) {
		if ( r < 1 || r > 4 ) {
			MessageBox("The number of relay isn't correct", "Modify", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
			(CEdit *)GetDlgItem(IDC_REL1)->SetFocus();
			((CEdit *)GetDlgItem(IDC_REL1))->SetSel(0,-1);
			return;
		}
	}

	r = GetDlgItemInt(IDC_HON1);
	if ( r < 0 || r > 23 ) {
		MessageBox("The time (hour) of calender isn't correct", "Modify", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		(CEdit *)GetDlgItem(IDC_HON1)->SetFocus();
		((CEdit *)GetDlgItem(IDC_HON1))->SetSel(0,-1);
		return;
	}

	r = GetDlgItemInt(IDC_MINON1);
	if ( r < 0 || r > 59 ) {
		MessageBox("The time (minute) of calender isn't correct", "Modify", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		(CEdit *)GetDlgItem(IDC_MINON1)->SetFocus();
		((CEdit *)GetDlgItem(IDC_MINON1))->SetSel(0,-1);
		return;
	}

	r = GetDlgItemInt(IDC_SECON1);
	if ( r < 0 || r > 59 ) {
		MessageBox("The time (second) of calender isn't correct", "Modify", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		(CEdit *)GetDlgItem(IDC_SECON1)->SetFocus();
		((CEdit *)GetDlgItem(IDC_SECON1))->SetSel(0,-1);
		return;
	}


	r = GetDlgItemInt(IDC_HOFF1);
	if ( r < 0 || r > 23 ) {
		MessageBox("The time (hour) of calender isn't correct", "Modify", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		(CEdit *)GetDlgItem(IDC_HOFF1)->SetFocus();
		((CEdit *)GetDlgItem(IDC_HOFF1))->SetSel(0,-1);
		return;
	}

	r = GetDlgItemInt(IDC_MINOFF1);
	if ( r < 0 || r > 59 ) {
		MessageBox("The time (minute) of calender isn't correct", "Modify", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		(CEdit *)GetDlgItem(IDC_MINOFF1)->SetFocus();
		((CEdit *)GetDlgItem(IDC_MINOFF1))->SetSel(0,-1);
		return;
	}

	r = GetDlgItemInt(IDC_SECOFF1);
	if ( r < 0 || r > 59 ) {
		MessageBox("The time (second) of calender isn't correct", "Modify", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		(CEdit *)GetDlgItem(IDC_SECOFF1)->SetFocus();
		((CEdit *)GetDlgItem(IDC_SECOFF1))->SetSel(0,-1);
		return;
	}
	
	//---
	
	r = GetDlgItemInt(IDC_DAYON1);
	if ( r < 0 || r > 31 ) {
		MessageBox("The date (day) of calender isn't correct", "Modify", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		(CEdit *)GetDlgItem(IDC_DAYON1)->SetFocus();
		((CEdit *)GetDlgItem(IDC_DAYON1))->SetSel(0,-1);
		return;
	}

	r = GetDlgItemInt(IDC_MONON1);
	if ( r < 0 || r > 12 ) {
		MessageBox("The date (month) of calender isn't correct", "Modify", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		(CEdit *)GetDlgItem(IDC_MONON1)->SetFocus();
		((CEdit *)GetDlgItem(IDC_MONON1))->SetSel(0,-1);
		return;
	}

	r = GetDlgItemInt(IDC_YON1);
	if ( r > 999 ) {
		MessageBox("The date (year) of calender isn't correct", "Modify", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		(CEdit *)GetDlgItem(IDC_YON1)->SetFocus();
		((CEdit *)GetDlgItem(IDC_YON1))->SetSel(0,-1);
		return;
	}
	
	r = GetDlgItemInt(IDC_DAYOFF1);
	if ( r < 0 || r > 31 ) {
		MessageBox("The date (day) of calender isn't correct", "Modify", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		(CEdit *)GetDlgItem(IDC_DAYOFF1)->SetFocus();
		((CEdit *)GetDlgItem(IDC_DAYOFF1))->SetSel(0,-1);
		return;
	}

	r = GetDlgItemInt(IDC_MONOFF1);
	if ( r < 0 || r > 12 ) {
		MessageBox("The date (month) of calender isn't correct", "Modify", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		(CEdit *)GetDlgItem(IDC_MONOFF1)->SetFocus();
		((CEdit *)GetDlgItem(IDC_MONOFF1))->SetSel(0,-1);
		return;
	}

	r = GetDlgItemInt(IDC_YOFF1);
	if ( r > 999 ) {
		MessageBox("The date (year) of calender isn't correct", "Modify", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		(CEdit *)GetDlgItem(IDC_YOFF1)->SetFocus();
		((CEdit *)GetDlgItem(IDC_YOFF1))->SetSel(0,-1);
		return;
	}


	CString	str;

	GetDlgItemText(IDC_T1, str);
	m_listcal.SetItemText( current_row, 1, str);
	GetDlgItemText(IDC_REL1, str);
	m_listcal.SetItemText( current_row, 2, str);


	GetDlgItemText(IDC_HON1,	str);
	m_listcal.SetItemText( current_row, 3, str);
	GetDlgItemText(IDC_MINON1,	str);
	m_listcal.SetItemText( current_row, 4, str);
	GetDlgItemText(IDC_SECON1,	str);
	m_listcal.SetItemText( current_row, 5, str);


	GetDlgItemText(IDC_HOFF1,	str);
	m_listcal.SetItemText( current_row, 6, str);
	GetDlgItemText(IDC_MINOFF1, str);
	m_listcal.SetItemText( current_row, 7, str);
	GetDlgItemText(IDC_SECOFF1, str);
	m_listcal.SetItemText( current_row, 8, str);


	GetDlgItemText(IDC_DAYON1,	str);
	m_listcal.SetItemText( current_row, 9, str);
	GetDlgItemText(IDC_MONON1,	str);
	m_listcal.SetItemText( current_row, 10, str);
	GetDlgItemText(IDC_YON1,	str);
	m_listcal.SetItemText( current_row, 11, str);


	GetDlgItemText(IDC_DAYOFF1, str);
	m_listcal.SetItemText( current_row, 12, str);
	GetDlgItemText(IDC_MONOFF1, str);
	m_listcal.SetItemText( current_row, 13, str);
	GetDlgItemText(IDC_YOFF1,	str);
	m_listcal.SetItemText( current_row, 14, str);	
}



void CWinefisconDlg::OnCalnclr() 
{
	// TODO: Add your control notification handler code here
	if ( current_row == -1 )	{
		MessageBox("The user isn't selected", "Modify", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		return;
	}
	if ( status_click == 0 ) {
		MessageBox("Please, select line by mouse", "Modify", MB_OK | MB_ICONASTERISK | MB_ICONINFORMATION);
		return;
	}

	m_listcal.SetItemText( current_row, 1,  "0");
	m_listcal.SetItemText( current_row, 2,  "0");
	m_listcal.SetItemText( current_row, 3,  "0");
	m_listcal.SetItemText( current_row, 4,  "0");
	m_listcal.SetItemText( current_row, 5,  "0");
	m_listcal.SetItemText( current_row, 6,  "0");
	m_listcal.SetItemText( current_row, 7,  "0");
	m_listcal.SetItemText( current_row, 8,  "0");
	m_listcal.SetItemText( current_row, 9,  "0");
	m_listcal.SetItemText( current_row, 10, "0");
	m_listcal.SetItemText( current_row, 11, "0");
	m_listcal.SetItemText( current_row, 12, "0");
	m_listcal.SetItemText( current_row, 13, "0");
	m_listcal.SetItemText( current_row, 14, "0");	
}

void CWinefisconDlg::OnClickListcal(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here	
	CString	str;
	
	*pResult = 0;

	current_row = m_listcal.GetNextItem( -1, LVNI_ALL | LVNI_FOCUSED);

	if ( current_row == -1 )	return;

	status_click = 1;

	SetDlgItemText(IDC_T1,		m_listcal.GetItemText(current_row, 1));
	SetDlgItemText(IDC_REL1,    m_listcal.GetItemText(current_row, 2));

	SetDlgItemText(IDC_HON1,    m_listcal.GetItemText(current_row, 3));
	SetDlgItemText(IDC_MINON1,  m_listcal.GetItemText(current_row, 4));
	SetDlgItemText(IDC_SECON1,  m_listcal.GetItemText(current_row, 5));

	SetDlgItemText(IDC_HOFF1,   m_listcal.GetItemText(current_row, 6));
	SetDlgItemText(IDC_MINOFF1, m_listcal.GetItemText(current_row, 7));
	SetDlgItemText(IDC_SECOFF1, m_listcal.GetItemText(current_row, 8));

	SetDlgItemText(IDC_DAYON1,  m_listcal.GetItemText(current_row, 9));
	SetDlgItemText(IDC_MONON1,  m_listcal.GetItemText(current_row,10));
	SetDlgItemText(IDC_YON1,	m_listcal.GetItemText(current_row,11));


	SetDlgItemText(IDC_DAYOFF1, m_listcal.GetItemText(current_row,12));
	SetDlgItemText(IDC_MONOFF1, m_listcal.GetItemText(current_row,13));
	SetDlgItemText(IDC_YOFF1,	m_listcal.GetItemText(current_row,14));

}



void	CWinefisconDlg::EnableToggle(void)
{
GetDlgItem(IDC_SETREL1)->EnableWindow(TRUE);
GetDlgItem(IDC_SETREL2)->EnableWindow(TRUE);
GetDlgItem(IDC_SETREL3)->EnableWindow(TRUE);
GetDlgItem(IDC_SETREL4)->EnableWindow(TRUE);

GetDlgItem(IDC_R1_MOD1)->EnableWindow(TRUE);
GetDlgItem(IDC_R1_MOD2)->EnableWindow(TRUE);
GetDlgItem(IDC_R1_MOD3)->EnableWindow(TRUE);
GetDlgItem(IDC_R1_MOD4)->EnableWindow(TRUE);
GetDlgItem(IDC_R1_MOD5)->EnableWindow(TRUE);

GetDlgItem(IDC_R2_MOD1)->EnableWindow(TRUE);
GetDlgItem(IDC_R2_MOD2)->EnableWindow(TRUE);
GetDlgItem(IDC_R2_MOD3)->EnableWindow(TRUE);
GetDlgItem(IDC_R2_MOD4)->EnableWindow(TRUE);
GetDlgItem(IDC_R2_MOD5)->EnableWindow(TRUE);

GetDlgItem(IDC_R3_MOD1)->EnableWindow(TRUE);
GetDlgItem(IDC_R3_MOD2)->EnableWindow(TRUE);
GetDlgItem(IDC_R3_MOD3)->EnableWindow(TRUE);
GetDlgItem(IDC_R3_MOD4)->EnableWindow(TRUE);
GetDlgItem(IDC_R3_MOD5)->EnableWindow(TRUE);

GetDlgItem(IDC_R4_MOD1)->EnableWindow(TRUE);
GetDlgItem(IDC_R4_MOD2)->EnableWindow(TRUE);
GetDlgItem(IDC_R4_MOD3)->EnableWindow(TRUE);
GetDlgItem(IDC_R4_MOD4)->EnableWindow(TRUE);
GetDlgItem(IDC_R4_MOD5)->EnableWindow(TRUE);

GetDlgItem(IDC_DREL1)->EnableWindow(TRUE);
GetDlgItem(IDC_DREL2)->EnableWindow(TRUE);
GetDlgItem(IDC_DREL3)->EnableWindow(TRUE);
GetDlgItem(IDC_DREL4)->EnableWindow(TRUE);
}



void	CWinefisconDlg::DisableToggle(void)
{
GetDlgItem(IDC_SETREL1)->EnableWindow(FALSE);
GetDlgItem(IDC_SETREL2)->EnableWindow(FALSE);
GetDlgItem(IDC_SETREL3)->EnableWindow(FALSE);
GetDlgItem(IDC_SETREL4)->EnableWindow(FALSE);

GetDlgItem(IDC_R1_MOD1)->EnableWindow(FALSE);
GetDlgItem(IDC_R1_MOD2)->EnableWindow(FALSE);
GetDlgItem(IDC_R1_MOD3)->EnableWindow(FALSE);
GetDlgItem(IDC_R1_MOD4)->EnableWindow(FALSE);
GetDlgItem(IDC_R1_MOD5)->EnableWindow(FALSE);

GetDlgItem(IDC_R2_MOD1)->EnableWindow(FALSE);
GetDlgItem(IDC_R2_MOD2)->EnableWindow(FALSE);
GetDlgItem(IDC_R2_MOD3)->EnableWindow(FALSE);
GetDlgItem(IDC_R2_MOD4)->EnableWindow(FALSE);
GetDlgItem(IDC_R2_MOD5)->EnableWindow(FALSE);

GetDlgItem(IDC_R3_MOD1)->EnableWindow(FALSE);
GetDlgItem(IDC_R3_MOD2)->EnableWindow(FALSE);
GetDlgItem(IDC_R3_MOD3)->EnableWindow(FALSE);
GetDlgItem(IDC_R3_MOD4)->EnableWindow(FALSE);
GetDlgItem(IDC_R3_MOD5)->EnableWindow(FALSE);

GetDlgItem(IDC_R4_MOD1)->EnableWindow(FALSE);
GetDlgItem(IDC_R4_MOD2)->EnableWindow(FALSE);
GetDlgItem(IDC_R4_MOD3)->EnableWindow(FALSE);
GetDlgItem(IDC_R4_MOD4)->EnableWindow(FALSE);
GetDlgItem(IDC_R4_MOD5)->EnableWindow(FALSE);

GetDlgItem(IDC_DREL1)->EnableWindow(FALSE);
GetDlgItem(IDC_DREL2)->EnableWindow(FALSE);
GetDlgItem(IDC_DREL3)->EnableWindow(FALSE);
GetDlgItem(IDC_DREL4)->EnableWindow(FALSE);
}
